#include "sub_ltgt.hpp"

SubstitutionLtGt::SubstitutionLtGt()
    : ScriptMacroprocessor::Macro("ltgt")
{
}

ScriptVariable SubstitutionLtGt::Expand(const ScriptVector &params) const
{
    if(params.Length() != 1)
        return ScriptVariableInv();

    ScriptVariable res("");
    const char *src = params[0].c_str();
    for(; *src; src++) {
        switch(*src) {
        case '<':
            res += "&lt;";
            break;
        case '>':
            res += "&gt;";
            break;
        case '&':
            res += "&amp;";
            break;
        // symbols <<">> and <<'>> are considered special by
        // JS function htmlspecialchars().
        // we don't understand the reason so we don't convert them here
        // we might add them here as well (" -> &quot;  ' -> &#039;)
        // if we experience any problems with them one day
        default:
            res += *src;
        }
    }
    return res;
}
